/*
 * DictionaryElement.c
 *
 *  Created on: 2009/07/08
 *      Author: ashida
 */
#include <stdlib.h>
#include <stdio.h>
#include <DictionaryElement.h>

/*------------------------------------------------------------------------------------*/
/* R[hݒ肷 */
void setCode(DictionaryElement *element, unsigned int code){
	element->code = code;
}
/*------------------------------------------------------------------------------------*/
/* ʂݒ肷 */
void setFeature(DictionaryElement *element, void *feature){
	element->feature = feature;
}
/*------------------------------------------------------------------------------------*/
/* vf̃mۂ */
DictionaryElement *allocDictionaryElement(void){
	DictionaryElement *element = (DictionaryElement *)malloc(sizeof(DictionaryElement));
	element->code = 0;
	element->feature = NULL;
	return element;
}
/*------------------------------------------------------------------------------------*/
/* vf̂߂̃ */
void freeDictionaryElement(DictionaryElement *element){
	free(element->feature);
	free(element);
}
/*------------------------------------------------------------------------------------*/
/* vfۑ */
void writeDictionaryElement(DictionaryElement *element, unsigned int dimension, FILE *fp){
	/* ϐ */
	unsigned int i;

	/* R[ho */
	fprintf(fp, "%d\n", element->code);
	/* ʂo */
	for(i=0; i<dimension; i++){
		fprintf(fp, "%d ", element->feature[i]);
	}
	/* s */
	fputc('\n', fp);
}
/*------------------------------------------------------------------------------------*/
/* vfǂݍ */
void readDictionaryElement(DictionaryElement *element, unsigned int dimension, FILE *fp){
	/* ϐ */
	unsigned int i;

	/* R[hǂݍ */
	fscanf(fp, "%d\n", &(element->code));

	/* ̊m */
	element->feature = (unsigned int *)malloc(sizeof(unsigned int)*dimension);

	/* ʂǂݍ */
	for(i=0; i<dimension; i++){
		fscanf(fp, "%d ", &(element->feature[i]));
	}

}
 /*------------------------------------------------------------------------------------*/
